Subject: Re: Open Routing Area meeting in Vienna

From: Lars Erik Gullerud <[email-masked]>
Date: 01 Aug 2003 09:00:07 +0200

Of course you can use multiple sessions and build separate meshes, and
for a lot of cases, this is in fact already the common way to do it. But
that hardly scales ad infinitum, and in fact causes even more
administrative hassles than if each service was carried in it's own
completely separate protocol, as you now also need N addresses set up on
each host to support N services in individual sessions.

My point was that while you say that "that is what making each AFI/SAFI
fully modular is all about", BGP has certain inherent properties that
does NOT make them fully modular. If you really want BGP to be the
generalized "stuff distribution protocol", then the protocol needs even
more changes to generalize it to this level. Whether making a "BGP5"
with these kinds of changes is the way to go or to create a brand new
"stuff distribution protocol" is something I don't really have an
opinion on - I just don't think BGP as we know it today is the answer.

I'll just restate my earlier comment - it's about isolating each service
so any failure will impact as small a portion of the customers as
possible. And as the complexity increases, and the chances for failure
with it, this becomes even more important.

/leg

On Thu, 2003-07-31 at 18:21, Robert Raszuk wrote:
> Lars,
> 
> There is nothing which would prohibit anyone today from using a
> dedicated BGP session for each AF mesh. So all probles you are
> describing are very valid, but can be already addressed today by few
> extra config lines. 
> 
> Further from TCP point of view adding another protocol or using multiple
> sessions for existing one is the same thing.
> 
> R.
> 
> > Lars Erik Gullerud wrote:
> > 
> > On Thu, 2003-07-31 at 17:33, Robert Raszuk wrote:
> > 
> > > Reg the sandwitch analogy ...
> > >
> > > Two (or N) smaller sandwitches could be easily done by cutting the 1
> > > meter (sorry 3 feet) long one into pieces (read modules) before
> > > consumption. That is exactly what making each new AFI/SAFI fully modular
> > > is all about. Notice also that once cutted it is packed in individual
> > > bags for distribution (each AFI/SAFI uses a separate update msg).
> > 
> > One problem as I see it right now though, is that if the contents of one
> > of those bags isn't satisfactory (i.e. an update message is invalid),
> > you throw the whole loaf of bread away (i.e. peer sends notification
> > message and tears down the BGP session). And as more and more different
> > sandwiches have to be made, the chances increase that a sloppy chef
> > mistakenly puts ham on one of them instead of salami, so this is a real
> > concern.
> > 
> > But since we are starting to stretch this sandwich analogy, let's go
> > back to cleartext - I have had the "pleasure" of observing the effects
> > on a network where buggy router code from vendor X generated bad update
> > messages for one AFI (in this case, vpnv4) and BGP sessions started
> > dropping all over the place. Which then ended up affecting a
> > substantially bigger portion of the customer mass than if only the VPN
> > service had gone down. Without going into details, let's just say the
> > guys in suits were not too happy, and the guys in jeans were sweating
> > heavily that day.
> > 
> > I'm not saying a separate protocol for every service is the preferred
> > way to go, but from an operators POV, a "soft" failure of one service
> > should ideally not affect all the other services being provided on the
> > same infrastructure, but rather contain the failure to that particular
> > service. Exactly how that is achieved however, is something we Ops guys
> > usually prefer to leave as an exercise to the people we pay obscene
> > amounts of money for those giant paperweights we stuff into our 19"
> > racks.
> > 
> > /leg

_______________________________________________
routing-discussion mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/routing-discussion

---

From: Henry Kilmer <[email-masked]>
Date: Thu, 31 Jul 2003 23:44:42 -0400

Dorian can correct me if I'm wrong here but I think the operators
would say that it is easier to do the Heimlich maneuver when the
object stuck is small.

Robert Raszuk writes:
>Jeff,
>
>> > But, if you're eating the same amount of food either way,
>> > then is it better to get a "bigger mouth," or a
>> > "smaller sandwich?"
>> 
>> Russ -
>>         To repeat myself, I don't think the issue is the raw
>> amount of data.  It is the complexity of the protocol
>> and rate of convergence protocol convergence.  (And I don't
>> think that BGP is linear in convergence, so two smaller
>> sandwichs would be better than one bigger one with the
>> same wieght.)
>
>Some folks on this list don't like to use knives and want to make small
>sandwitches when there is only one piece of bread already in action. So
>first let's make sure we have a bread ready on the table for a second
>sandwitch then start putting salami on it :).
>
>R.
>

---

From: Henry Kilmer <[email-masked]>
Date: Thu, 31 Jul 2003 23:44:42 -0400

---

From: Lars Erik Gullerud <[email-masked]>
Date: 01 Aug 2003 09:00:07 +0200

/leg

---

From: Robert Raszuk <[email-masked]>
Date: Fri, 01 Aug 2003 09:55:12 +0200

Lars,

Agree with your comment. 

So while putting aside the debate if evlution of BGP4 into BGP5 makes
sens or not could we focus on actually listing problems in BGP4 by name
which are giving you the impresion that "BGP has certain inherent
properties that does NOT make them fully modular."

No - I am not saying that BGP4 is perfect as is today - but I am trying
to get some constrictive feedback for us vendors to make sure that the
areas we need to improve in BGP4 are in line with what you folks are
struggling the most with while running daily operation.

We have first one:

1. Separate BGP sessions for each AFI/SAFI require "trashing" IGP with
new addresses (IBGP) or multiple interfaces (EBGP) cases.

Thx !
R.

---

From: Robert Raszuk <[email-masked]>
Date: Fri, 01 Aug 2003 09:55:12 +0200

Lars,

Agree with your comment. 

We have first one:

Thx !
R.

---

From: Eric Rosen <[email-masked]>
Date: Fri, 01 Aug 2003 13:02:36 -0400

Lars> causes  even more  administrative  hassles than  if  each service  was
Lars> carried in it's own completely separate protocol, as you now also need
Lars> N addresses  set up on each  host to support N  services in individual
Lars> sessions. 

If we were to  decide that we should have multiple BGP  instances on a node,
then using a  different port number for each would seem  to be more sensible
than using a different address for each.

---

From: Eric Rosen <[email-masked]>
Date: Fri, 01 Aug 2003 13:02:36 -0400

---

From: Eric Rosen <[email-masked]>
Date: Fri, 01 Aug 2003 13:07:55 -0400

Lars> One problem as I  see it right now though, is that  if the contents of
Lars> one  of those  bags  isn't  satisfactory (i.e.  an  update message  is
Lars> invalid),  you throw the  whole loaf  of bread  away (i.e.  peer sends
Lars> notification message and tears down the BGP session). 

This point is well taken.  

But don't you think that whatever happens here, this should be fixed in BGP?
Even if BGP  just carried the IPv4 and IPv6 address  families, you might not
want an error in one to take down the whole session.

---

From: Eric Rosen <[email-masked]>
Date: Fri, 01 Aug 2003 13:07:55 -0400

---

From: Curtis Villamizar <[email-masked]>
Date: Fri, 01 Aug 2003 21:12:30 -0400

In message <[email-masked]>, Eric Rosen write
> want an error in one to take down the whole session.  

Right now a cease is not AF specific and neither is a crash of the BGP
task.

Curtis

---

From: Curtis Villamizar <[email-masked]>
Date: Fri, 01 Aug 2003 21:12:30 -0400

Curtis

---

From: Yakov Rekhter <[email-masked]>
Date: Wed, 06 Aug 2003 10:08:46 -0700

> Right now a cease is not AF specific and neither is a crash of the BGP

So, as Eric suggested, one could fix this in BGP by making a cease AF 
specific.

Yakov.

---

From: Yakov Rekhter <[email-masked]>
Date: Wed, 06 Aug 2003 10:08:46 -0700

Yakov.

---

From: Enke Chen <[email-masked]>
Date: Wed, 06 Aug 2003 11:41:48 -0700

Yakov,

> Message-Id: <[email-masked]>
> To: [email-masked]
> Cc: [email-masked], Lars Erik Gullerud <[email-masked]>,
> 	[email-masked], Jeff Parker <[email-masked]>,
> 	"'Russ White'" <[email-masked]>,
> 	Kurt Erik Lindqvist <[email-masked]>,
> 	Randy Bush <[email-masked]>, [email-masked]
> Subject: Re: Open Routing Area meeting in Vienna 
> In-Reply-To: Your message of "Fri, 01 Aug 2003 21:12:30 EDT."
>              <[email-masked]> 
> Date: Wed, 06 Aug 2003 10:08:46 -0700
> 
> > 

It could also be fixed in BGP by withdrawing the specific AF capability
(using the BGP Dynamic Capability).

-- Enke

---

From: Enke Chen <[email-masked]>
Date: Wed, 06 Aug 2003 11:41:48 -0700

Yakov,

-- Enke